\r with_GRH.gp
\r testfin.gp
\r qfminim_trie.gp
\p 3
pc = ex_poids_connus();
to_cert=[];
addtocert(u,v)=concat(u,select(x->(x[3]<-0.00001),v));
tri(li)=select(x->(x[3]>-0.0001),li);
explaindifflist(li)={my(a);
a=select(x->(x[3]>-0.001)&&(x[3]<-0.0001),li);
for(i=1,#a,print(a[i][1],"  l=",a[i][2],"  ",a[i][3]));
};

print("First eliminate the U of Prop. 4.1 (1) with multiplicity >1");
print("li = [[[0, 0, 1, 7, 13, 17, 21, 23, 23], 0, 1000, 0, 0]];");
li = [[[0, 0, 1, 7, 13, 17, 21, 23, 23], 0, 1000, 0, 0]];
print("for(i=0, 4, li = testfin_liste(li, 4.0+0.5*i, 2, pc[1..26], 1, 3));");
for(i=0, 4, li = testfin_liste(li, 4.0+0.5*i, 2, pc[1..26], 1, 3));
to_cert=addtocert(to_cert,li); 
print("linear combination found:");

for(i=1,1,print(testtovec(to_cert[#to_cert+1-i],0,2)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],2)));

print("Now import a list of 198 elements U containing that of Prop. 4.1 (2)"); 
li1=read("list_of_resistant_w23_mult1");

print("for(i=1, 4, li1 = testfin_liste(li1, 5.0+i*.5, 1, pc[1..1]));");
for(i=1, 4, li1 = testfin_liste(li1, 5.0+i*.5, 1, pc[1..1]));
to_cert=addtocert(to_cert,li1); li2=tri(li1); 
print(#li2," elements remaining");
print("contradictions found not counted as killed");
explaindifflist(li1);

print("for(i=0, 6, li2 = testfin_liste(li2, 4.0+i*.5, 1, pc[1..26],1,2));");
for(i=0, 6, li2 = testfin_liste(li2, 4.0+i*.5, 1, pc[1..26],1,2));
to_cert=addtocert(to_cert,li2); li3=tri(li2); 
print(#li3," elements remaining");
print("contradictions found not counted as killed");
explaindifflist(li2);

print("for(i=0, 6, li3 = testfin_liste(li3, 4.0+i*.5, 1, pc[1..23],3,3));");
for(i=0, 6, li3 = testfin_liste(li3, 4.0+i*.5, 1, pc[1..23],3,3));
to_cert=addtocert(to_cert,li3); li4=tri(li3); 
print(#li4," elements remaining");
print("contradictions found not counted as killed");
explaindifflist(li3);

print("for(i=0, 6, li4 = testfin_liste(li4, 4.0+i*.5, 1, pc[1..23],4,4));");
for(i=0, 6, li4 = testfin_liste(li4, 4.0+i*.5, 1, pc[1..23],4,4));
to_cert=addtocert(to_cert,li4); li5=tri(li4); 
print(#li5," elements remaining");

print("for(i=1, 4, li5 = testfin_liste(li5, 4.0+i*.5, 1, pc[1..23],5,5));");
for(i=1, 4, li5 = testfin_liste(li5, 4.0+i*.5, 1, pc[1..23],5,5));
to_cert=addtocert(to_cert,li5); li6=tri(li5); 
print(#li6," elements remaining");
print("contradictions found not counted as killed");
explaindifflist(li5);

print("The last 4 linear combinations found with negative CF are:");
for(i=1,4,print(testtovec(to_cert[#to_cert+1-i],1,1)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],1)));

print("for(i=0, 2, li6 = testfin_liste(li6, 5.0+i*.5, 1, pc[1..23],6,6));");
for(i=0, 2, li6 = testfin_liste(li6, 5.0+i*.5, 1, pc[1..23],6,6));
to_cert=addtocert(to_cert,li6); li7=tri(li6); 
print(#li7," elements remaining, namely");
for(i=1,#li7,print(li7[i][1]));

print("The last 2 linear combinations found with negative CF are:");

for(i=1,2,print(testtovec(to_cert[#to_cert+1-i],1,1)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],1)));

print("li7=testfin_liste(li7, 5.5, 1, pc[1..23],7,7);");
li7=testfin_liste(li7, 5.5, 1, pc[1..23],7,7);
to_cert=addtocert(to_cert,li7); li8=tri(li7); 
print(#li8," elements remaining");
print("contradictions found not counted as killed");
explaindifflist(li7);

print("The last 2 linear combinations found with negative CF are:");
for(i=1,1,print(testtovec(to_cert[#to_cert+1-i],1,1)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],1)));


print("After a long search, we have been led to consider the following:");
print("good_part=vecextract(pc[1..23],2093253);");
good_part=vecextract(pc[1..23],2093253);
print("This is the following 13 element subset of pc[1..23]:");
print(good_part);
print("a=testfin_liste([li8[2]], 6.36, 1, good_part);");
a=testfin_liste([li8[2]], 6.36, 1, good_part);
print(a[1]);
print("NB : it said 0 killed as -0.000566 >-0.001";)
print("the linear combination is:");
a[1][4]=2093253;
print(testtovec(a[1],1,1));
print("and we have CF=", CF(a[1],a[1][2],1));
to_cert=addtocert(to_cert,a);


print("to certify with interval arithmetic : the ",#to_cert," linear combinations stored in the vector to_cert");


