\r without_GRH.gp
\r testfin.gp
\r qfminim_trie.gp
\r cas_regulier_autodual.gp
allocatemem(2^29);
\p 3
pc=ex_poids_connus();
to_cert=[];
addtocert(u,v)=concat(u,select(x->(x[3]<-0.00001),v));
tri(li)=select(x->(x[3]>-0.0001),li);

print("lw24_reg = select(x->dimw(x)>12, enum_wts_orth(24));");
lw24_reg = select(x->dimw(x)>12, enum_wts_orth(24));
print("Select regular, motivic weight 24, elements U with eps(U)=1 and dim U >12, card = ",#lw24_reg)

li1 = vector(#lw24_reg, i, [lw24_reg[i], 0, 1000, 0, 0]);

print("li1 = testfin_liste(li1, 3.0, 1, pc[1..11], 1, 1);");
li1 = testfin_liste(li1, 3.0, 1, pc[1..11], 1, 1);
to_cert=addtocert(to_cert,li1); li2=tri(li1); 
print(#li2," elements remaining");

print("for(i=0, 4, li2 = testfin_liste(li2, 3.0+i, 1, pc[1..15], 1, 2));");
for(i=0, 4, li2 = testfin_liste(li2, 3.0+i, 1, pc[1..15], 1, 2));
to_cert=addtocert(to_cert,li2); li3=tri(li2); 
print(#li3," elements remaining");

print("for(i=0, 4, li3 = testfin_liste(li3, 3.0+i, 1, pc[1..15], 3, 4));");
for(i=0, 4, li3 = testfin_liste(li3, 3.0+i, 1, pc[1..15], 3, 4));
to_cert=addtocert(to_cert,li3); li4=tri(li3); 
print(#li4," elements remaining");

print("for(i=1, 3, li4 = testfin_liste(li4, 3.0+i, 1, pc[1..15], 5, 5));");
for(i=1, 3, li4 = testfin_liste(li4, 3.0+i, 1, pc[1..15], 5, 5));
to_cert=addtocert(to_cert,li4); li5=tri(li4); 
print(#li5," elements remaining");

print("for(i=0, 2, li5 = testfin_liste(li5, 5.0+i, 1, pc[1..15], 6, 6));");
for(i=0, 2, li5 = testfin_liste(li5, 5.0+i, 1, pc[1..15], 6, 6));
to_cert=addtocert(to_cert,li5); li6=tri(li5); 
print(#li6," elements remaining");

print("The last 2 linear combinations found with negative CF are:");
for(i=1,2,print(testtovec(to_cert[#to_cert+1-i],1,1)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],1)))

print("for(i=0, 2, li6 = testfin_liste(li6, 5.0+.5*i, 1, pc[1..15], 7, 7));");
for(i=0, 2, li6 = testfin_liste(li6, 5.0+.5*i, 1, pc[1..15], 7, 7));
to_cert=addtocert(to_cert,li6); li7=tri(li6); 
print(#li7," elements remaining:");
for(i=1,#li7,print(li7[i][1]));

print("The last linear combination found with negative CF is:");
for(i=1,1,print(testtovec(to_cert[#to_cert+1-i],1,1)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],1)))

print("to certify with interval arithmetic : the ",#to_cert," linear combinations stored in the vector to_cert");
