ca = {}

def r1(w, l):
    res = R(0)
    for n in range(N+1):
        res += r(R(2*l*(1/2+w/4+n)))
    return 2*l*(res.add_error(r(2*l*(1/2+w/4+N+1))/(1-exp(-2*l))))

def r2(l):
    if (N+1)*l<1:
        raise ValueError
    res = R(0)
    for n in range(1, N+1):
        res += (-1)^(n+1)*n*r(R(n*l))
    return 2*l*(res.add_error((N+1)*r((N+1)*l)))

def r3(l):
    res = R(0)
    for n in range(0, N+1):
        res += (-1)^n*r(R((n+1/2)*l))
    return 4*l*(res.add_error(r((N+3/2)*l)))

def J(w, l):
    t = psi(C(1/2+w/4+I*Pi/(2*l)))
    return log(Pi) - t.real() + t.imag()/Pi\
            - psi_prime(1/2+w/4+I*Pi/(2*l)).real()/(2*l) + r1(w,l)

def diff1eps(l):
    return R(1) + 2*Pi/l*(phi(1+I*Pi/l)).imag()\
            + 2*Pi/l^2*(phi_prime(1+I*Pi/l)).imag() + r2(l)

def Phi0(l):
    return l*8/Pi^2

def Phi12(l):
    return 4*(phi(1/2+I*Pi/l)).real() - 4/Pi*(phi(1/2+I*Pi/l)).imag()\
            + 4/l*(phi_prime(1/2+I*Pi/l)).real() + r3(l)
