def save_ell_tr():
    n = 0
    for D in elliptic_traces_SO_odd:
        if n==0:
            n += 1
            continue
        with open("data/ell_tr/ell_tr_SO"+str(2*n+1)+".txt", "w") as fp:
            for dw in it_dw_SO_odd(n, *wt_bounds):
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 0
    for D in elliptic_traces_Sp:
        if n==0:
            n += 1
            continue
        with open("data/ell_tr/ell_tr_Sp"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_Sp(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 0
    for D in elliptic_traces_SO_even:
        if n==0:
            n += 2
            continue
        with open("data/ell_tr/ell_tr_SO"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_even(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 2

def save_EP_char():
    n = 1
    for D in EPchar_list_SO_odd:
        with open("data/EPchar/EPchar_SO"+str(2*n+1)+".txt", "w") as fp:
            for dw in it_dw_SO_odd(n, *wt_bounds):
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 1
    for D in EPchar_list_Sp:
        with open("data/EPchar/EPchar_Sp"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_Sp(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 2
    for D in EPchar_list_SO_even:
        with open("data/EPchar/EPchar_SO"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_even(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 2

def save_new_para():
    n = 1
    for D in new_sympl_para_list:
        with open("data/new_para/sympl_"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_odd(n, *wt_bounds):
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 0
    for D in new_orth_odd_para_list:
        if n==0:
            n = 1
            continue
        with open("data/new_para/orth_"+str(2*n+1)+".txt", "w") as fp:
            for dw in it_dw_Sp(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 1
    n = 2
    for D in new_orth_even_para_list:
        with open("data/new_para/orth_"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_even(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                fp.write(str(dw)+":"+str(D[dw])+"\n")
        n += 2

def save_nonzero_new_para_human():
    n = 1
    for D in new_sympl_para_list:
        with open("data/human_new_para/sympl_"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_odd(n, *wt_bounds):
                val = D[dw]
                if not val in ZZ or val<0:
                    print("SO"+str(2*n+1)+", "+str(dw)+": "+str(val))
                    raise ValueError
                if val==0:
                    continue
                hw = tuple(dw[i]+n-1/2-i for i in range(n))
                fp.write(str(hw)+":"+str(val)+"\n")
        n += 1
    n = 0
    for D in new_orth_odd_para_list:
        if n==0:
            n = 1
            continue
        with open("data/human_new_para/orth_"+str(2*n+1)+".txt", "w") as fp:
            for dw in it_dw_Sp(n, *wt_bounds):
                val = D[dw]
                if not val in ZZ or val<0:
                    print("Sp"+str(2*n)+", "+str(dw)+": "+str(val))
                    raise ValueError
                if val==0:
                    continue
                hw = tuple(dw[i]+n-i for i in range(n))
                fp.write(str(hw)+":"+str(val)+"\n")
        n += 1
    n = 2
    for D in new_orth_even_para_list:
        with open("data/human_new_para/orth_"+str(2*n)+".txt", "w") as fp:
            for dw in it_dw_SO_even(n, *wt_bounds):
                val = D[dw]
                if not val in ZZ or val<0:
                    print("SO"+str(2*n)+", "+str(dw)+": "+str(val))
                    raise ValueError
                if val==0:
                    continue
                hw = tuple(dw[i]+n-1-i for i in range(n))
                fp.write(str(hw)+":"+str(val)+"\n")
        n += 2

def save_siegel():
    n = 1
    for D in dim_siegel:
        with open("data/siegel/siegel_genus"+str(n)+".txt", "w") as fp:
            for dw in it_dw_Sp(n, *wt_bounds):
                if sum(dw)%2:
                    continue
                wt = tuple(x+n+1 for x in dw)
                fp.write(str(wt)+":"+str(D[dw])+"\n")
        n += 1

